/*
 * jQueryFaceSelector plugin.
 * @author Igogo <igogozombieit@gmail.com>
 * Copyright (c) 2013 Igogo

 * jQueryFaceSelector extends jQuery and jQuery UI.
 * more about jQuery can be found at http://jquery.com/.
 * more about jQuery UI can be found at http://jqueryui.com/.
 * @version: 0.1.a
 */

(function($){
	$.fn.jQueryFaceSelector = function(options) {
		var opts = $.extend({}, $.fn.jQueryFaceSelector.defaults, options);
		return this.each(function(){
			$.fn.jQueryFaceSelector.start($(this), opts);
	  	});
	};

	//default 
	$.fn.jQueryFaceSelector.defaults = {
		data: [],
		selectWidth: '100px',
		selectHeight: '100px'
	};

	//If image wrapped by tag <a>
	$.fn.jQueryFaceSelector._hrefSaver = null;

	//initialization image for selector
	$.fn.jQueryFaceSelector.start = function(el, opts){
		var img = new Image(),
			self = this;

        var select = $('<div id="jQueryFaceSelectorSelect"/>').css({
            width: opts.selectWidth,
            height: opts.selectHeight,
            position: 'absolute', 
            border: '1px solid #ffffff', 
            zIndex: 999999,
            display: 'block'
        });

		img.onload = function(){
			var w = $('<div class="jQueryFaceSelectorWrapper"/>').css({
        				width: this.width,
        				height: this.height,
        				position: 'relative'
        			});
            el.wrap(w);

			el.click(function(e){
				e.preventDefault();
                e.stopPropagation();

	            if(el.parent('a').length){
	                $.fn.jQueryFaceSelector._hrefSaver = el.parent('a').attr('href');
	                el.parent('a').attr('href', 'javascript://');
	            }

                var wrapper = el.parent('.jQueryFaceSelectorWrapper');

				coords = self.getCoordinates(e, wrapper);
                select.css({
                    top: coords[0],
                    left: coords[1]
                }).resizable({
                    containment: wrapper,
                    resize: function(event, ui){
                        height = select.css('height');
                        width = select.css('width');
                    },
                    stop: function(event, ui){
                        height = select.css('height');
                        width = select.css('width');
                    }
                }).draggable({
                    containment: wrapper,
                    cursor: 'move',
                    drag: function(event, ui){
                        top = select.css('top');
                        left = select.css('left');
                    },
                    stop: function(event, ui){
                        top = select.css('top');
                        left = select.css('left');
                    }
                });

                wrapper.append(select);
			});
		}
		img.src = el.attr('src');
	};

	//get true mouse cursor coordinates
	$.fn.jQueryFaceSelector.getCoordinates = function(e, wrapper){
        //$("#ObjectToCheck").offset().left
		var coords = [e.clientX, e.clientY];
        console.log(coords);
		return coords;
	};

	$.fn.jQueryFaceSelector.getScrollXY = function(){
        var scrOfX = 0, scrOfY = 0;
        if( typeof( window.pageYOffset ) == 'number' ) {
            //Netscape compliant
            scrOfY = window.pageYOffset;
            scrOfX = window.pageXOffset;
        } else if( document.body && ( document.body.scrollLeft || document.body.scrollTop ) ) {
            //DOM compliant
            scrOfY = document.body.scrollTop;
            scrOfX = document.body.scrollLeft;
        }else if( document.documentElement 
        && ( document.documentElement.scrollLeft || document.documentElement.scrollTop ) ) {
            //IE6 standards compliant mode
            scrOfY = document.documentElement.scrollTop;
            scrOfX = document.documentElement.scrollLeft;
        }
        return [ scrOfX, scrOfY ];
    };
})(jQuery);
